/* Device.c generated by valac 0.35.5, the Vala compiler
 * generated from Device.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2016 elementary LLC.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */

#include <glib.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>


#define BLUETOOTH_SERVICES_TYPE_DEVICE (bluetooth_services_device_get_type ())
#define BLUETOOTH_SERVICES_DEVICE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), BLUETOOTH_SERVICES_TYPE_DEVICE, BluetoothServicesDevice))
#define BLUETOOTH_SERVICES_IS_DEVICE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), BLUETOOTH_SERVICES_TYPE_DEVICE))
#define BLUETOOTH_SERVICES_DEVICE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), BLUETOOTH_SERVICES_TYPE_DEVICE, BluetoothServicesDeviceIface))

typedef struct _BluetoothServicesDevice BluetoothServicesDevice;
typedef struct _BluetoothServicesDeviceIface BluetoothServicesDeviceIface;

#define BLUETOOTH_SERVICES_TYPE_DEVICE_PROXY (bluetooth_services_device_proxy_get_type ())
typedef GDBusProxy BluetoothServicesDeviceProxy;
typedef GDBusProxyClass BluetoothServicesDeviceProxyClass;
#define _g_free0(var) (var = (g_free (var), NULL))

struct _BluetoothServicesDeviceIface {
	GTypeInterface parent_iface;
	void (*cancel_pairing) (BluetoothServicesDevice* self, GError** error);
	void (*connect) (BluetoothServicesDevice* self, GError** error);
	void (*connect_profile) (BluetoothServicesDevice* self, const gchar* UUID, GError** error);
	void (*disconnect) (BluetoothServicesDevice* self, GError** error);
	void (*disconnect_profile) (BluetoothServicesDevice* self, const gchar* UUID, GError** error);
	void (*pair) (BluetoothServicesDevice* self, GError** error);
	gchar** (*get_UUIDs) (BluetoothServicesDevice* self, int* result_length1);
	void (*set_UUIDs) (BluetoothServicesDevice* self, gchar** value, int value_length1);
	gboolean (*get_blocked) (BluetoothServicesDevice* self);
	void (*set_blocked) (BluetoothServicesDevice* self, gboolean value);
	gboolean (*get_connected) (BluetoothServicesDevice* self);
	void (*set_connected) (BluetoothServicesDevice* self, gboolean value);
	gboolean (*get_legacy_pairing) (BluetoothServicesDevice* self);
	void (*set_legacy_pairing) (BluetoothServicesDevice* self, gboolean value);
	gboolean (*get_paired) (BluetoothServicesDevice* self);
	void (*set_paired) (BluetoothServicesDevice* self, gboolean value);
	gboolean (*get_trusted) (BluetoothServicesDevice* self);
	void (*set_trusted) (BluetoothServicesDevice* self, gboolean value);
	gint16 (*get_RSSI) (BluetoothServicesDevice* self);
	void (*set_RSSI) (BluetoothServicesDevice* self, gint16 value);
	char* (*get_adapter) (BluetoothServicesDevice* self);
	void (*set_adapter) (BluetoothServicesDevice* self, const char* value);
	gchar* (*get_address) (BluetoothServicesDevice* self);
	void (*set_address) (BluetoothServicesDevice* self, const gchar* value);
	gchar* (*get_alias) (BluetoothServicesDevice* self);
	void (*set_alias) (BluetoothServicesDevice* self, const gchar* value);
	gchar* (*get_icon) (BluetoothServicesDevice* self);
	void (*set_icon) (BluetoothServicesDevice* self, const gchar* value);
	gchar* (*get_modalias) (BluetoothServicesDevice* self);
	void (*set_modalias) (BluetoothServicesDevice* self, const gchar* value);
	gchar* (*get_name) (BluetoothServicesDevice* self);
	void (*set_name) (BluetoothServicesDevice* self, const gchar* value);
	guint16 (*get_appearance) (BluetoothServicesDevice* self);
	void (*set_appearance) (BluetoothServicesDevice* self, guint16 value);
	guint32 (*get_class) (BluetoothServicesDevice* self);
	void (*set_class) (BluetoothServicesDevice* self, guint32 value);
};



GType bluetooth_services_device_proxy_get_type (void) G_GNUC_CONST;
guint bluetooth_services_device_register_object (void* object, GDBusConnection* connection, const gchar* path, GError** error);
GType bluetooth_services_device_get_type (void) G_GNUC_CONST;
void bluetooth_services_device_cancel_pairing (BluetoothServicesDevice* self, GError** error);
void bluetooth_services_device_connect (BluetoothServicesDevice* self, GError** error);
void bluetooth_services_device_connect_profile (BluetoothServicesDevice* self, const gchar* UUID, GError** error);
void bluetooth_services_device_disconnect (BluetoothServicesDevice* self, GError** error);
void bluetooth_services_device_disconnect_profile (BluetoothServicesDevice* self, const gchar* UUID, GError** error);
void bluetooth_services_device_pair (BluetoothServicesDevice* self, GError** error);
gchar** bluetooth_services_device_get_UUIDs (BluetoothServicesDevice* self, int* result_length1);
static void bluetooth_services_device_set_UUIDs (BluetoothServicesDevice* self, gchar** value, int value_length1);
gboolean bluetooth_services_device_get_blocked (BluetoothServicesDevice* self);
void bluetooth_services_device_set_blocked (BluetoothServicesDevice* self, gboolean value);
gboolean bluetooth_services_device_get_connected (BluetoothServicesDevice* self);
static void bluetooth_services_device_set_connected (BluetoothServicesDevice* self, gboolean value);
gboolean bluetooth_services_device_get_legacy_pairing (BluetoothServicesDevice* self);
static void bluetooth_services_device_set_legacy_pairing (BluetoothServicesDevice* self, gboolean value);
gboolean bluetooth_services_device_get_paired (BluetoothServicesDevice* self);
static void bluetooth_services_device_set_paired (BluetoothServicesDevice* self, gboolean value);
gboolean bluetooth_services_device_get_trusted (BluetoothServicesDevice* self);
void bluetooth_services_device_set_trusted (BluetoothServicesDevice* self, gboolean value);
gint16 bluetooth_services_device_get_RSSI (BluetoothServicesDevice* self);
static void bluetooth_services_device_set_RSSI (BluetoothServicesDevice* self, gint16 value);
char* bluetooth_services_device_get_adapter (BluetoothServicesDevice* self);
static void bluetooth_services_device_set_adapter (BluetoothServicesDevice* self, const char* value);
gchar* bluetooth_services_device_get_address (BluetoothServicesDevice* self);
static void bluetooth_services_device_set_address (BluetoothServicesDevice* self, const gchar* value);
gchar* bluetooth_services_device_get_alias (BluetoothServicesDevice* self);
void bluetooth_services_device_set_alias (BluetoothServicesDevice* self, const gchar* value);
gchar* bluetooth_services_device_get_icon (BluetoothServicesDevice* self);
static void bluetooth_services_device_set_icon (BluetoothServicesDevice* self, const gchar* value);
gchar* bluetooth_services_device_get_modalias (BluetoothServicesDevice* self);
static void bluetooth_services_device_set_modalias (BluetoothServicesDevice* self, const gchar* value);
gchar* bluetooth_services_device_get_name (BluetoothServicesDevice* self);
static void bluetooth_services_device_set_name (BluetoothServicesDevice* self, const gchar* value);
guint16 bluetooth_services_device_get_appearance (BluetoothServicesDevice* self);
static void bluetooth_services_device_set_appearance (BluetoothServicesDevice* self, guint16 value);
guint32 bluetooth_services_device_get_class (BluetoothServicesDevice* self);
static void bluetooth_services_device_set_class (BluetoothServicesDevice* self, guint32 value);
static void bluetooth_services_device_proxy_g_signal (GDBusProxy* proxy, const gchar* sender_name, const gchar* signal_name, GVariant* parameters);
static void bluetooth_services_device_proxy_cancel_pairing (BluetoothServicesDevice* self, GError** error);
static void bluetooth_services_device_proxy_connect (BluetoothServicesDevice* self, GError** error);
static void bluetooth_services_device_proxy_connect_profile (BluetoothServicesDevice* self, const gchar* UUID, GError** error);
static void bluetooth_services_device_proxy_disconnect (BluetoothServicesDevice* self, GError** error);
static void bluetooth_services_device_proxy_disconnect_profile (BluetoothServicesDevice* self, const gchar* UUID, GError** error);
static void bluetooth_services_device_proxy_pair (BluetoothServicesDevice* self, GError** error);
static gchar** bluetooth_services_device_dbus_proxy_get_UUIDs (BluetoothServicesDevice* self, int* result_length1);
static void bluetooth_services_device_dbus_proxy_set_UUIDs (BluetoothServicesDevice* self, gchar** value, int value_length1);
static gboolean bluetooth_services_device_dbus_proxy_get_blocked (BluetoothServicesDevice* self);
static void bluetooth_services_device_dbus_proxy_set_blocked (BluetoothServicesDevice* self, gboolean value);
static gboolean bluetooth_services_device_dbus_proxy_get_connected (BluetoothServicesDevice* self);
static void bluetooth_services_device_dbus_proxy_set_connected (BluetoothServicesDevice* self, gboolean value);
static gboolean bluetooth_services_device_dbus_proxy_get_legacy_pairing (BluetoothServicesDevice* self);
static void bluetooth_services_device_dbus_proxy_set_legacy_pairing (BluetoothServicesDevice* self, gboolean value);
static gboolean bluetooth_services_device_dbus_proxy_get_paired (BluetoothServicesDevice* self);
static void bluetooth_services_device_dbus_proxy_set_paired (BluetoothServicesDevice* self, gboolean value);
static gboolean bluetooth_services_device_dbus_proxy_get_trusted (BluetoothServicesDevice* self);
static void bluetooth_services_device_dbus_proxy_set_trusted (BluetoothServicesDevice* self, gboolean value);
static gint16 bluetooth_services_device_dbus_proxy_get_RSSI (BluetoothServicesDevice* self);
static void bluetooth_services_device_dbus_proxy_set_RSSI (BluetoothServicesDevice* self, gint16 value);
static char* bluetooth_services_device_dbus_proxy_get_adapter (BluetoothServicesDevice* self);
static void bluetooth_services_device_dbus_proxy_set_adapter (BluetoothServicesDevice* self, const char* value);
static gchar* bluetooth_services_device_dbus_proxy_get_address (BluetoothServicesDevice* self);
static void bluetooth_services_device_dbus_proxy_set_address (BluetoothServicesDevice* self, const gchar* value);
static gchar* bluetooth_services_device_dbus_proxy_get_alias (BluetoothServicesDevice* self);
static void bluetooth_services_device_dbus_proxy_set_alias (BluetoothServicesDevice* self, const gchar* value);
static gchar* bluetooth_services_device_dbus_proxy_get_icon (BluetoothServicesDevice* self);
static void bluetooth_services_device_dbus_proxy_set_icon (BluetoothServicesDevice* self, const gchar* value);
static gchar* bluetooth_services_device_dbus_proxy_get_modalias (BluetoothServicesDevice* self);
static void bluetooth_services_device_dbus_proxy_set_modalias (BluetoothServicesDevice* self, const gchar* value);
static gchar* bluetooth_services_device_dbus_proxy_get_name (BluetoothServicesDevice* self);
static void bluetooth_services_device_dbus_proxy_set_name (BluetoothServicesDevice* self, const gchar* value);
static guint16 bluetooth_services_device_dbus_proxy_get_appearance (BluetoothServicesDevice* self);
static void bluetooth_services_device_dbus_proxy_set_appearance (BluetoothServicesDevice* self, guint16 value);
static guint32 bluetooth_services_device_dbus_proxy_get_class (BluetoothServicesDevice* self);
static void bluetooth_services_device_dbus_proxy_set_class (BluetoothServicesDevice* self, guint32 value);
static void bluetooth_services_device_proxy_bluetooth_services_device_interface_init (BluetoothServicesDeviceIface* iface);
static void _dbus_bluetooth_services_device_cancel_pairing (BluetoothServicesDevice* self, GVariant* _parameters_, GDBusMethodInvocation* invocation);
static void _dbus_bluetooth_services_device_connect (BluetoothServicesDevice* self, GVariant* _parameters_, GDBusMethodInvocation* invocation);
static void _dbus_bluetooth_services_device_connect_profile (BluetoothServicesDevice* self, GVariant* _parameters_, GDBusMethodInvocation* invocation);
static void _dbus_bluetooth_services_device_disconnect (BluetoothServicesDevice* self, GVariant* _parameters_, GDBusMethodInvocation* invocation);
static void _dbus_bluetooth_services_device_disconnect_profile (BluetoothServicesDevice* self, GVariant* _parameters_, GDBusMethodInvocation* invocation);
static void _dbus_bluetooth_services_device_pair (BluetoothServicesDevice* self, GVariant* _parameters_, GDBusMethodInvocation* invocation);
static void bluetooth_services_device_dbus_interface_method_call (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* method_name, GVariant* parameters, GDBusMethodInvocation* invocation, gpointer user_data);
static GVariant* bluetooth_services_device_dbus_interface_get_property (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* property_name, GError** error, gpointer user_data);
static GVariant* _dbus_bluetooth_services_device_get_UUIDs (BluetoothServicesDevice* self);
static GVariant* _dbus_bluetooth_services_device_get_blocked (BluetoothServicesDevice* self);
static GVariant* _dbus_bluetooth_services_device_get_connected (BluetoothServicesDevice* self);
static GVariant* _dbus_bluetooth_services_device_get_legacy_pairing (BluetoothServicesDevice* self);
static GVariant* _dbus_bluetooth_services_device_get_paired (BluetoothServicesDevice* self);
static GVariant* _dbus_bluetooth_services_device_get_trusted (BluetoothServicesDevice* self);
static GVariant* _dbus_bluetooth_services_device_get_RSSI (BluetoothServicesDevice* self);
static GVariant* _dbus_bluetooth_services_device_get_adapter (BluetoothServicesDevice* self);
static GVariant* _dbus_bluetooth_services_device_get_address (BluetoothServicesDevice* self);
static GVariant* _dbus_bluetooth_services_device_get_alias (BluetoothServicesDevice* self);
static GVariant* _dbus_bluetooth_services_device_get_icon (BluetoothServicesDevice* self);
static GVariant* _dbus_bluetooth_services_device_get_modalias (BluetoothServicesDevice* self);
static GVariant* _dbus_bluetooth_services_device_get_name (BluetoothServicesDevice* self);
static GVariant* _dbus_bluetooth_services_device_get_appearance (BluetoothServicesDevice* self);
static GVariant* _dbus_bluetooth_services_device_get_class (BluetoothServicesDevice* self);
static gboolean bluetooth_services_device_dbus_interface_set_property (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* property_name, GVariant* value, GError** error, gpointer user_data);
static void _dbus_bluetooth_services_device_set_UUIDs (BluetoothServicesDevice* self, GVariant* _value);
static void _dbus_bluetooth_services_device_set_blocked (BluetoothServicesDevice* self, GVariant* _value);
static void _dbus_bluetooth_services_device_set_connected (BluetoothServicesDevice* self, GVariant* _value);
static void _dbus_bluetooth_services_device_set_legacy_pairing (BluetoothServicesDevice* self, GVariant* _value);
static void _dbus_bluetooth_services_device_set_paired (BluetoothServicesDevice* self, GVariant* _value);
static void _dbus_bluetooth_services_device_set_trusted (BluetoothServicesDevice* self, GVariant* _value);
static void _dbus_bluetooth_services_device_set_RSSI (BluetoothServicesDevice* self, GVariant* _value);
static void _dbus_bluetooth_services_device_set_adapter (BluetoothServicesDevice* self, GVariant* _value);
static void _dbus_bluetooth_services_device_set_address (BluetoothServicesDevice* self, GVariant* _value);
static void _dbus_bluetooth_services_device_set_alias (BluetoothServicesDevice* self, GVariant* _value);
static void _dbus_bluetooth_services_device_set_icon (BluetoothServicesDevice* self, GVariant* _value);
static void _dbus_bluetooth_services_device_set_modalias (BluetoothServicesDevice* self, GVariant* _value);
static void _dbus_bluetooth_services_device_set_name (BluetoothServicesDevice* self, GVariant* _value);
static void _dbus_bluetooth_services_device_set_appearance (BluetoothServicesDevice* self, GVariant* _value);
static void _dbus_bluetooth_services_device_set_class (BluetoothServicesDevice* self, GVariant* _value);
static void _bluetooth_services_device_unregister_object (gpointer user_data);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);

static const GDBusArgInfo * const _bluetooth_services_device_dbus_arg_info_cancel_pairing_in[] = {NULL};
static const GDBusArgInfo * const _bluetooth_services_device_dbus_arg_info_cancel_pairing_out[] = {NULL};
static const GDBusMethodInfo _bluetooth_services_device_dbus_method_info_cancel_pairing = {-1, "CancelPairing", (GDBusArgInfo **) (&_bluetooth_services_device_dbus_arg_info_cancel_pairing_in), (GDBusArgInfo **) (&_bluetooth_services_device_dbus_arg_info_cancel_pairing_out)};
static const GDBusArgInfo * const _bluetooth_services_device_dbus_arg_info_connect_in[] = {NULL};
static const GDBusArgInfo * const _bluetooth_services_device_dbus_arg_info_connect_out[] = {NULL};
static const GDBusMethodInfo _bluetooth_services_device_dbus_method_info_connect = {-1, "Connect", (GDBusArgInfo **) (&_bluetooth_services_device_dbus_arg_info_connect_in), (GDBusArgInfo **) (&_bluetooth_services_device_dbus_arg_info_connect_out)};
static const GDBusArgInfo _bluetooth_services_device_dbus_arg_info_connect_profile_UUID = {-1, "UUID", "s"};
static const GDBusArgInfo * const _bluetooth_services_device_dbus_arg_info_connect_profile_in[] = {&_bluetooth_services_device_dbus_arg_info_connect_profile_UUID, NULL};
static const GDBusArgInfo * const _bluetooth_services_device_dbus_arg_info_connect_profile_out[] = {NULL};
static const GDBusMethodInfo _bluetooth_services_device_dbus_method_info_connect_profile = {-1, "ConnectProfile", (GDBusArgInfo **) (&_bluetooth_services_device_dbus_arg_info_connect_profile_in), (GDBusArgInfo **) (&_bluetooth_services_device_dbus_arg_info_connect_profile_out)};
static const GDBusArgInfo * const _bluetooth_services_device_dbus_arg_info_disconnect_in[] = {NULL};
static const GDBusArgInfo * const _bluetooth_services_device_dbus_arg_info_disconnect_out[] = {NULL};
static const GDBusMethodInfo _bluetooth_services_device_dbus_method_info_disconnect = {-1, "Disconnect", (GDBusArgInfo **) (&_bluetooth_services_device_dbus_arg_info_disconnect_in), (GDBusArgInfo **) (&_bluetooth_services_device_dbus_arg_info_disconnect_out)};
static const GDBusArgInfo _bluetooth_services_device_dbus_arg_info_disconnect_profile_UUID = {-1, "UUID", "s"};
static const GDBusArgInfo * const _bluetooth_services_device_dbus_arg_info_disconnect_profile_in[] = {&_bluetooth_services_device_dbus_arg_info_disconnect_profile_UUID, NULL};
static const GDBusArgInfo * const _bluetooth_services_device_dbus_arg_info_disconnect_profile_out[] = {NULL};
static const GDBusMethodInfo _bluetooth_services_device_dbus_method_info_disconnect_profile = {-1, "DisconnectProfile", (GDBusArgInfo **) (&_bluetooth_services_device_dbus_arg_info_disconnect_profile_in), (GDBusArgInfo **) (&_bluetooth_services_device_dbus_arg_info_disconnect_profile_out)};
static const GDBusArgInfo * const _bluetooth_services_device_dbus_arg_info_pair_in[] = {NULL};
static const GDBusArgInfo * const _bluetooth_services_device_dbus_arg_info_pair_out[] = {NULL};
static const GDBusMethodInfo _bluetooth_services_device_dbus_method_info_pair = {-1, "Pair", (GDBusArgInfo **) (&_bluetooth_services_device_dbus_arg_info_pair_in), (GDBusArgInfo **) (&_bluetooth_services_device_dbus_arg_info_pair_out)};
static const GDBusMethodInfo * const _bluetooth_services_device_dbus_method_info[] = {&_bluetooth_services_device_dbus_method_info_cancel_pairing, &_bluetooth_services_device_dbus_method_info_connect, &_bluetooth_services_device_dbus_method_info_connect_profile, &_bluetooth_services_device_dbus_method_info_disconnect, &_bluetooth_services_device_dbus_method_info_disconnect_profile, &_bluetooth_services_device_dbus_method_info_pair, NULL};
static const GDBusSignalInfo * const _bluetooth_services_device_dbus_signal_info[] = {NULL};
static const GDBusPropertyInfo _bluetooth_services_device_dbus_property_info_UUIDs = {-1, "UUIDs", "as", G_DBUS_PROPERTY_INFO_FLAGS_READABLE | G_DBUS_PROPERTY_INFO_FLAGS_WRITABLE};
static const GDBusPropertyInfo _bluetooth_services_device_dbus_property_info_blocked = {-1, "Blocked", "b", G_DBUS_PROPERTY_INFO_FLAGS_READABLE | G_DBUS_PROPERTY_INFO_FLAGS_WRITABLE};
static const GDBusPropertyInfo _bluetooth_services_device_dbus_property_info_connected = {-1, "Connected", "b", G_DBUS_PROPERTY_INFO_FLAGS_READABLE | G_DBUS_PROPERTY_INFO_FLAGS_WRITABLE};
static const GDBusPropertyInfo _bluetooth_services_device_dbus_property_info_legacy_pairing = {-1, "LegacyPairing", "b", G_DBUS_PROPERTY_INFO_FLAGS_READABLE | G_DBUS_PROPERTY_INFO_FLAGS_WRITABLE};
static const GDBusPropertyInfo _bluetooth_services_device_dbus_property_info_paired = {-1, "Paired", "b", G_DBUS_PROPERTY_INFO_FLAGS_READABLE | G_DBUS_PROPERTY_INFO_FLAGS_WRITABLE};
static const GDBusPropertyInfo _bluetooth_services_device_dbus_property_info_trusted = {-1, "Trusted", "b", G_DBUS_PROPERTY_INFO_FLAGS_READABLE | G_DBUS_PROPERTY_INFO_FLAGS_WRITABLE};
static const GDBusPropertyInfo _bluetooth_services_device_dbus_property_info_RSSI = {-1, "RSSI", "n", G_DBUS_PROPERTY_INFO_FLAGS_READABLE | G_DBUS_PROPERTY_INFO_FLAGS_WRITABLE};
static const GDBusPropertyInfo _bluetooth_services_device_dbus_property_info_adapter = {-1, "Adapter", "o", G_DBUS_PROPERTY_INFO_FLAGS_READABLE | G_DBUS_PROPERTY_INFO_FLAGS_WRITABLE};
static const GDBusPropertyInfo _bluetooth_services_device_dbus_property_info_address = {-1, "Address", "s", G_DBUS_PROPERTY_INFO_FLAGS_READABLE | G_DBUS_PROPERTY_INFO_FLAGS_WRITABLE};
static const GDBusPropertyInfo _bluetooth_services_device_dbus_property_info_alias = {-1, "Alias", "s", G_DBUS_PROPERTY_INFO_FLAGS_READABLE | G_DBUS_PROPERTY_INFO_FLAGS_WRITABLE};
static const GDBusPropertyInfo _bluetooth_services_device_dbus_property_info_icon = {-1, "Icon", "s", G_DBUS_PROPERTY_INFO_FLAGS_READABLE | G_DBUS_PROPERTY_INFO_FLAGS_WRITABLE};
static const GDBusPropertyInfo _bluetooth_services_device_dbus_property_info_modalias = {-1, "Modalias", "s", G_DBUS_PROPERTY_INFO_FLAGS_READABLE | G_DBUS_PROPERTY_INFO_FLAGS_WRITABLE};
static const GDBusPropertyInfo _bluetooth_services_device_dbus_property_info_name = {-1, "Name", "s", G_DBUS_PROPERTY_INFO_FLAGS_READABLE | G_DBUS_PROPERTY_INFO_FLAGS_WRITABLE};
static const GDBusPropertyInfo _bluetooth_services_device_dbus_property_info_appearance = {-1, "Appearance", "q", G_DBUS_PROPERTY_INFO_FLAGS_READABLE | G_DBUS_PROPERTY_INFO_FLAGS_WRITABLE};
static const GDBusPropertyInfo _bluetooth_services_device_dbus_property_info_class = {-1, "Class", "u", G_DBUS_PROPERTY_INFO_FLAGS_READABLE | G_DBUS_PROPERTY_INFO_FLAGS_WRITABLE};
static const GDBusPropertyInfo * const _bluetooth_services_device_dbus_property_info[] = {&_bluetooth_services_device_dbus_property_info_UUIDs, &_bluetooth_services_device_dbus_property_info_blocked, &_bluetooth_services_device_dbus_property_info_connected, &_bluetooth_services_device_dbus_property_info_legacy_pairing, &_bluetooth_services_device_dbus_property_info_paired, &_bluetooth_services_device_dbus_property_info_trusted, &_bluetooth_services_device_dbus_property_info_RSSI, &_bluetooth_services_device_dbus_property_info_adapter, &_bluetooth_services_device_dbus_property_info_address, &_bluetooth_services_device_dbus_property_info_alias, &_bluetooth_services_device_dbus_property_info_icon, &_bluetooth_services_device_dbus_property_info_modalias, &_bluetooth_services_device_dbus_property_info_name, &_bluetooth_services_device_dbus_property_info_appearance, &_bluetooth_services_device_dbus_property_info_class, NULL};
static const GDBusInterfaceInfo _bluetooth_services_device_dbus_interface_info = {-1, "org.bluez.Device1", (GDBusMethodInfo **) (&_bluetooth_services_device_dbus_method_info), (GDBusSignalInfo **) (&_bluetooth_services_device_dbus_signal_info), (GDBusPropertyInfo **) (&_bluetooth_services_device_dbus_property_info)};
static const GDBusInterfaceVTable _bluetooth_services_device_dbus_interface_vtable = {bluetooth_services_device_dbus_interface_method_call, bluetooth_services_device_dbus_interface_get_property, bluetooth_services_device_dbus_interface_set_property};

void bluetooth_services_device_cancel_pairing (BluetoothServicesDevice* self, GError** error) {
#line 23 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Services/Device.vala"
	g_return_if_fail (self != NULL);
#line 23 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Services/Device.vala"
	BLUETOOTH_SERVICES_DEVICE_GET_INTERFACE (self)->cancel_pairing (self, error);
#line 253 "Device.c"
}


void bluetooth_services_device_connect (BluetoothServicesDevice* self, GError** error) {
#line 24 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Services/Device.vala"
	g_return_if_fail (self != NULL);
#line 24 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Services/Device.vala"
	BLUETOOTH_SERVICES_DEVICE_GET_INTERFACE (self)->connect (self, error);
#line 262 "Device.c"
}


void bluetooth_services_device_connect_profile (BluetoothServicesDevice* self, const gchar* UUID, GError** error) {
#line 25 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Services/Device.vala"
	g_return_if_fail (self != NULL);
#line 25 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Services/Device.vala"
	BLUETOOTH_SERVICES_DEVICE_GET_INTERFACE (self)->connect_profile (self, UUID, error);
#line 271 "Device.c"
}


void bluetooth_services_device_disconnect (BluetoothServicesDevice* self, GError** error) {
#line 26 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Services/Device.vala"
	g_return_if_fail (self != NULL);
#line 26 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Services/Device.vala"
	BLUETOOTH_SERVICES_DEVICE_GET_INTERFACE (self)->disconnect (self, error);
#line 280 "Device.c"
}


void bluetooth_services_device_disconnect_profile (BluetoothServicesDevice* self, const gchar* UUID, GError** error) {
#line 27 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Services/Device.vala"
	g_return_if_fail (self != NULL);
#line 27 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Services/Device.vala"
	BLUETOOTH_SERVICES_DEVICE_GET_INTERFACE (self)->disconnect_profile (self, UUID, error);
#line 289 "Device.c"
}


void bluetooth_services_device_pair (BluetoothServicesDevice* self, GError** error) {
#line 28 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Services/Device.vala"
	g_return_if_fail (self != NULL);
#line 28 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Services/Device.vala"
	BLUETOOTH_SERVICES_DEVICE_GET_INTERFACE (self)->pair (self, error);
#line 298 "Device.c"
}


gchar** bluetooth_services_device_get_UUIDs (BluetoothServicesDevice* self, int* result_length1) {
#line 30 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Services/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 30 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Services/Device.vala"
	return BLUETOOTH_SERVICES_DEVICE_GET_INTERFACE (self)->get_UUIDs (self, result_length1);
#line 307 "Device.c"
}


static void bluetooth_services_device_set_UUIDs (BluetoothServicesDevice* self, gchar** value, int value_length1) {
#line 30 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Services/Device.vala"
	g_return_if_fail (self != NULL);
#line 30 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Services/Device.vala"
	BLUETOOTH_SERVICES_DEVICE_GET_INTERFACE (self)->set_UUIDs (self, value, value_length1);
#line 316 "Device.c"
}


gboolean bluetooth_services_device_get_blocked (BluetoothServicesDevice* self) {
#line 31 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Services/Device.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 31 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Services/Device.vala"
	return BLUETOOTH_SERVICES_DEVICE_GET_INTERFACE (self)->get_blocked (self);
#line 325 "Device.c"
}


void bluetooth_services_device_set_blocked (BluetoothServicesDevice* self, gboolean value) {
#line 31 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Services/Device.vala"
	g_return_if_fail (self != NULL);
#line 31 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Services/Device.vala"
	BLUETOOTH_SERVICES_DEVICE_GET_INTERFACE (self)->set_blocked (self, value);
#line 334 "Device.c"
}


gboolean bluetooth_services_device_get_connected (BluetoothServicesDevice* self) {
#line 32 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Services/Device.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 32 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Services/Device.vala"
	return BLUETOOTH_SERVICES_DEVICE_GET_INTERFACE (self)->get_connected (self);
#line 343 "Device.c"
}


static void bluetooth_services_device_set_connected (BluetoothServicesDevice* self, gboolean value) {
#line 32 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Services/Device.vala"
	g_return_if_fail (self != NULL);
#line 32 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Services/Device.vala"
	BLUETOOTH_SERVICES_DEVICE_GET_INTERFACE (self)->set_connected (self, value);
#line 352 "Device.c"
}


gboolean bluetooth_services_device_get_legacy_pairing (BluetoothServicesDevice* self) {
#line 33 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Services/Device.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 33 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Services/Device.vala"
	return BLUETOOTH_SERVICES_DEVICE_GET_INTERFACE (self)->get_legacy_pairing (self);
#line 361 "Device.c"
}


static void bluetooth_services_device_set_legacy_pairing (BluetoothServicesDevice* self, gboolean value) {
#line 33 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Services/Device.vala"
	g_return_if_fail (self != NULL);
#line 33 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Services/Device.vala"
	BLUETOOTH_SERVICES_DEVICE_GET_INTERFACE (self)->set_legacy_pairing (self, value);
#line 370 "Device.c"
}


gboolean bluetooth_services_device_get_paired (BluetoothServicesDevice* self) {
#line 34 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Services/Device.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 34 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Services/Device.vala"
	return BLUETOOTH_SERVICES_DEVICE_GET_INTERFACE (self)->get_paired (self);
#line 379 "Device.c"
}


static void bluetooth_services_device_set_paired (BluetoothServicesDevice* self, gboolean value) {
#line 34 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Services/Device.vala"
	g_return_if_fail (self != NULL);
#line 34 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Services/Device.vala"
	BLUETOOTH_SERVICES_DEVICE_GET_INTERFACE (self)->set_paired (self, value);
#line 388 "Device.c"
}


gboolean bluetooth_services_device_get_trusted (BluetoothServicesDevice* self) {
#line 35 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Services/Device.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 35 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Services/Device.vala"
	return BLUETOOTH_SERVICES_DEVICE_GET_INTERFACE (self)->get_trusted (self);
#line 397 "Device.c"
}


void bluetooth_services_device_set_trusted (BluetoothServicesDevice* self, gboolean value) {
#line 35 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Services/Device.vala"
	g_return_if_fail (self != NULL);
#line 35 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Services/Device.vala"
	BLUETOOTH_SERVICES_DEVICE_GET_INTERFACE (self)->set_trusted (self, value);
#line 406 "Device.c"
}


gint16 bluetooth_services_device_get_RSSI (BluetoothServicesDevice* self) {
#line 36 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Services/Device.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 36 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Services/Device.vala"
	return BLUETOOTH_SERVICES_DEVICE_GET_INTERFACE (self)->get_RSSI (self);
#line 415 "Device.c"
}


static void bluetooth_services_device_set_RSSI (BluetoothServicesDevice* self, gint16 value) {
#line 36 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Services/Device.vala"
	g_return_if_fail (self != NULL);
#line 36 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Services/Device.vala"
	BLUETOOTH_SERVICES_DEVICE_GET_INTERFACE (self)->set_RSSI (self, value);
#line 424 "Device.c"
}


char* bluetooth_services_device_get_adapter (BluetoothServicesDevice* self) {
#line 37 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Services/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 37 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Services/Device.vala"
	return BLUETOOTH_SERVICES_DEVICE_GET_INTERFACE (self)->get_adapter (self);
#line 433 "Device.c"
}


static void bluetooth_services_device_set_adapter (BluetoothServicesDevice* self, const char* value) {
#line 37 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Services/Device.vala"
	g_return_if_fail (self != NULL);
#line 37 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Services/Device.vala"
	BLUETOOTH_SERVICES_DEVICE_GET_INTERFACE (self)->set_adapter (self, value);
#line 442 "Device.c"
}


gchar* bluetooth_services_device_get_address (BluetoothServicesDevice* self) {
#line 38 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Services/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 38 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Services/Device.vala"
	return BLUETOOTH_SERVICES_DEVICE_GET_INTERFACE (self)->get_address (self);
#line 451 "Device.c"
}


static void bluetooth_services_device_set_address (BluetoothServicesDevice* self, const gchar* value) {
#line 38 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Services/Device.vala"
	g_return_if_fail (self != NULL);
#line 38 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Services/Device.vala"
	BLUETOOTH_SERVICES_DEVICE_GET_INTERFACE (self)->set_address (self, value);
#line 460 "Device.c"
}


gchar* bluetooth_services_device_get_alias (BluetoothServicesDevice* self) {
#line 39 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Services/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 39 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Services/Device.vala"
	return BLUETOOTH_SERVICES_DEVICE_GET_INTERFACE (self)->get_alias (self);
#line 469 "Device.c"
}


void bluetooth_services_device_set_alias (BluetoothServicesDevice* self, const gchar* value) {
#line 39 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Services/Device.vala"
	g_return_if_fail (self != NULL);
#line 39 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Services/Device.vala"
	BLUETOOTH_SERVICES_DEVICE_GET_INTERFACE (self)->set_alias (self, value);
#line 478 "Device.c"
}


gchar* bluetooth_services_device_get_icon (BluetoothServicesDevice* self) {
#line 40 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Services/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 40 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Services/Device.vala"
	return BLUETOOTH_SERVICES_DEVICE_GET_INTERFACE (self)->get_icon (self);
#line 487 "Device.c"
}


static void bluetooth_services_device_set_icon (BluetoothServicesDevice* self, const gchar* value) {
#line 40 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Services/Device.vala"
	g_return_if_fail (self != NULL);
#line 40 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Services/Device.vala"
	BLUETOOTH_SERVICES_DEVICE_GET_INTERFACE (self)->set_icon (self, value);
#line 496 "Device.c"
}


gchar* bluetooth_services_device_get_modalias (BluetoothServicesDevice* self) {
#line 41 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Services/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 41 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Services/Device.vala"
	return BLUETOOTH_SERVICES_DEVICE_GET_INTERFACE (self)->get_modalias (self);
#line 505 "Device.c"
}


static void bluetooth_services_device_set_modalias (BluetoothServicesDevice* self, const gchar* value) {
#line 41 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Services/Device.vala"
	g_return_if_fail (self != NULL);
#line 41 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Services/Device.vala"
	BLUETOOTH_SERVICES_DEVICE_GET_INTERFACE (self)->set_modalias (self, value);
#line 514 "Device.c"
}


gchar* bluetooth_services_device_get_name (BluetoothServicesDevice* self) {
#line 42 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Services/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 42 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Services/Device.vala"
	return BLUETOOTH_SERVICES_DEVICE_GET_INTERFACE (self)->get_name (self);
#line 523 "Device.c"
}


static void bluetooth_services_device_set_name (BluetoothServicesDevice* self, const gchar* value) {
#line 42 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Services/Device.vala"
	g_return_if_fail (self != NULL);
#line 42 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Services/Device.vala"
	BLUETOOTH_SERVICES_DEVICE_GET_INTERFACE (self)->set_name (self, value);
#line 532 "Device.c"
}


guint16 bluetooth_services_device_get_appearance (BluetoothServicesDevice* self) {
#line 43 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Services/Device.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 43 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Services/Device.vala"
	return BLUETOOTH_SERVICES_DEVICE_GET_INTERFACE (self)->get_appearance (self);
#line 541 "Device.c"
}


static void bluetooth_services_device_set_appearance (BluetoothServicesDevice* self, guint16 value) {
#line 43 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Services/Device.vala"
	g_return_if_fail (self != NULL);
#line 43 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Services/Device.vala"
	BLUETOOTH_SERVICES_DEVICE_GET_INTERFACE (self)->set_appearance (self, value);
#line 550 "Device.c"
}


guint32 bluetooth_services_device_get_class (BluetoothServicesDevice* self) {
#line 44 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Services/Device.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 44 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Services/Device.vala"
	return BLUETOOTH_SERVICES_DEVICE_GET_INTERFACE (self)->get_class (self);
#line 559 "Device.c"
}


static void bluetooth_services_device_set_class (BluetoothServicesDevice* self, guint32 value) {
#line 44 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Services/Device.vala"
	g_return_if_fail (self != NULL);
#line 44 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Services/Device.vala"
	BLUETOOTH_SERVICES_DEVICE_GET_INTERFACE (self)->set_class (self, value);
#line 568 "Device.c"
}


static void bluetooth_services_device_base_init (BluetoothServicesDeviceIface * iface) {
#line 22 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Services/Device.vala"
	static gboolean initialized = FALSE;
#line 22 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Services/Device.vala"
	if (!initialized) {
#line 22 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/Services/Device.vala"
		initialized = TRUE;
#line 579 "Device.c"
	}
}


GType bluetooth_services_device_get_type (void) {
	static volatile gsize bluetooth_services_device_type_id__volatile = 0;
	if (g_once_init_enter (&bluetooth_services_device_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (BluetoothServicesDeviceIface), (GBaseInitFunc) bluetooth_services_device_base_init, (GBaseFinalizeFunc) NULL, (GClassInitFunc) NULL, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
		GType bluetooth_services_device_type_id;
		bluetooth_services_device_type_id = g_type_register_static (G_TYPE_INTERFACE, "BluetoothServicesDevice", &g_define_type_info, 0);
		g_type_interface_add_prerequisite (bluetooth_services_device_type_id, G_TYPE_OBJECT);
		g_type_set_qdata (bluetooth_services_device_type_id, g_quark_from_static_string ("vala-dbus-proxy-type"), (void*) bluetooth_services_device_proxy_get_type);
		g_type_set_qdata (bluetooth_services_device_type_id, g_quark_from_static_string ("vala-dbus-interface-name"), "org.bluez.Device1");
		g_type_set_qdata (bluetooth_services_device_type_id, g_quark_from_static_string ("vala-dbus-interface-info"), (void*) (&_bluetooth_services_device_dbus_interface_info));
		g_type_set_qdata (bluetooth_services_device_type_id, g_quark_from_static_string ("vala-dbus-register-object"), (void*) bluetooth_services_device_register_object);
		g_once_init_leave (&bluetooth_services_device_type_id__volatile, bluetooth_services_device_type_id);
	}
	return bluetooth_services_device_type_id__volatile;
}


G_DEFINE_TYPE_EXTENDED (BluetoothServicesDeviceProxy, bluetooth_services_device_proxy, G_TYPE_DBUS_PROXY, 0, G_IMPLEMENT_INTERFACE (BLUETOOTH_SERVICES_TYPE_DEVICE, bluetooth_services_device_proxy_bluetooth_services_device_interface_init) )
static void bluetooth_services_device_proxy_class_init (BluetoothServicesDeviceProxyClass* klass) {
	G_DBUS_PROXY_CLASS (klass)->g_signal = bluetooth_services_device_proxy_g_signal;
}


static void bluetooth_services_device_proxy_g_signal (GDBusProxy* proxy, const gchar* sender_name, const gchar* signal_name, GVariant* parameters) {
}


static void bluetooth_services_device_proxy_init (BluetoothServicesDeviceProxy* self) {
}


static void bluetooth_services_device_proxy_cancel_pairing (BluetoothServicesDevice* self, GError** error) {
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	G_IO_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.bluez.Device1", "CancelPairing");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return;
	}
	g_object_unref (_reply_message);
}


static void bluetooth_services_device_proxy_connect (BluetoothServicesDevice* self, GError** error) {
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	G_IO_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.bluez.Device1", "Connect");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return;
	}
	g_object_unref (_reply_message);
}


static void bluetooth_services_device_proxy_connect_profile (BluetoothServicesDevice* self, const gchar* UUID, GError** error) {
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	G_IO_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.bluez.Device1", "ConnectProfile");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (UUID));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return;
	}
	g_object_unref (_reply_message);
}


static void bluetooth_services_device_proxy_disconnect (BluetoothServicesDevice* self, GError** error) {
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	G_IO_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.bluez.Device1", "Disconnect");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return;
	}
	g_object_unref (_reply_message);
}


static void bluetooth_services_device_proxy_disconnect_profile (BluetoothServicesDevice* self, const gchar* UUID, GError** error) {
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	G_IO_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.bluez.Device1", "DisconnectProfile");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (UUID));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return;
	}
	g_object_unref (_reply_message);
}


static void bluetooth_services_device_proxy_pair (BluetoothServicesDevice* self, GError** error) {
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	G_IO_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.bluez.Device1", "Pair");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return;
	}
	g_object_unref (_reply_message);
}


static gchar** bluetooth_services_device_dbus_proxy_get_UUIDs (BluetoothServicesDevice* self, int* result_length1) {
	GVariant *_inner_reply;
	gchar** _result;
	int _result_length1;
	gchar** _tmp29_;
	int _tmp29__length;
	int _tmp29__size;
	int _tmp29__length1;
	GVariantIter _tmp30_;
	GVariant* _tmp31_;
	_inner_reply = g_dbus_proxy_get_cached_property ((GDBusProxy *) self, "UUIDs");
	if (!_inner_reply) {
		GVariant *_arguments;
		GVariant *_reply;
		GVariantBuilder _arguments_builder;
		g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("org.bluez.Device1"));
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("UUIDs"));
		_arguments = g_variant_builder_end (&_arguments_builder);
		_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Get", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
		if (!_reply) {
			return NULL;
		}
		g_variant_get (_reply, "(v)", &_inner_reply);
		g_variant_unref (_reply);
	}
	_result_length1 = 0;
	_tmp29_ = g_new (gchar*, 5);
	_tmp29__length = 0;
	_tmp29__size = 4;
	_tmp29__length1 = 0;
	g_variant_iter_init (&_tmp30_, _inner_reply);
	for (; (_tmp31_ = g_variant_iter_next_value (&_tmp30_)) != NULL; _tmp29__length1++) {
		if (_tmp29__size == _tmp29__length) {
			_tmp29__size = 2 * _tmp29__size;
			_tmp29_ = g_renew (gchar*, _tmp29_, _tmp29__size + 1);
		}
		_tmp29_[_tmp29__length++] = g_variant_dup_string (_tmp31_, NULL);
		g_variant_unref (_tmp31_);
	}
	_result_length1 = _tmp29__length1;
	_tmp29_[_tmp29__length] = NULL;
	_result = _tmp29_;
	*result_length1 = _result_length1;
	g_variant_unref (_inner_reply);
	return _result;
}


static void bluetooth_services_device_dbus_proxy_set_UUIDs (BluetoothServicesDevice* self, gchar** value, int value_length1) {
	GVariant *_arguments;
	GVariant *_reply;
	GVariantBuilder _arguments_builder;
	gchar** _tmp32_;
	GVariantBuilder _tmp33_;
	int _tmp34_;
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("org.bluez.Device1"));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("UUIDs"));
	g_variant_builder_open (&_arguments_builder, G_VARIANT_TYPE_VARIANT);
	_tmp32_ = value;
	g_variant_builder_init (&_tmp33_, G_VARIANT_TYPE ("as"));
	for (_tmp34_ = 0; _tmp34_ < value_length1; _tmp34_++) {
		g_variant_builder_add_value (&_tmp33_, g_variant_new_string (*_tmp32_));
		_tmp32_++;
	}
	g_variant_builder_add_value (&_arguments_builder, g_variant_builder_end (&_tmp33_));
	g_variant_builder_close (&_arguments_builder);
	_arguments = g_variant_builder_end (&_arguments_builder);
	_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Set", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
	if (!_reply) {
		return;
	}
	g_variant_unref (_reply);
}


static gboolean bluetooth_services_device_dbus_proxy_get_blocked (BluetoothServicesDevice* self) {
	GVariant *_inner_reply;
	gboolean _result;
	_inner_reply = g_dbus_proxy_get_cached_property ((GDBusProxy *) self, "Blocked");
	if (!_inner_reply) {
		GVariant *_arguments;
		GVariant *_reply;
		GVariantBuilder _arguments_builder;
		g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("org.bluez.Device1"));
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("Blocked"));
		_arguments = g_variant_builder_end (&_arguments_builder);
		_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Get", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
		if (!_reply) {
			gboolean _tmp35_ = FALSE;
			return _tmp35_;
		}
		g_variant_get (_reply, "(v)", &_inner_reply);
		g_variant_unref (_reply);
	}
	_result = g_variant_get_boolean (_inner_reply);
	g_variant_unref (_inner_reply);
	return _result;
}


static void bluetooth_services_device_dbus_proxy_set_blocked (BluetoothServicesDevice* self, gboolean value) {
	GVariant *_arguments;
	GVariant *_reply;
	GVariantBuilder _arguments_builder;
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("org.bluez.Device1"));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("Blocked"));
	g_variant_builder_open (&_arguments_builder, G_VARIANT_TYPE_VARIANT);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_boolean (value));
	g_variant_builder_close (&_arguments_builder);
	_arguments = g_variant_builder_end (&_arguments_builder);
	_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Set", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
	if (!_reply) {
		return;
	}
	g_variant_unref (_reply);
}


static gboolean bluetooth_services_device_dbus_proxy_get_connected (BluetoothServicesDevice* self) {
	GVariant *_inner_reply;
	gboolean _result;
	_inner_reply = g_dbus_proxy_get_cached_property ((GDBusProxy *) self, "Connected");
	if (!_inner_reply) {
		GVariant *_arguments;
		GVariant *_reply;
		GVariantBuilder _arguments_builder;
		g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("org.bluez.Device1"));
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("Connected"));
		_arguments = g_variant_builder_end (&_arguments_builder);
		_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Get", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
		if (!_reply) {
			gboolean _tmp36_ = FALSE;
			return _tmp36_;
		}
		g_variant_get (_reply, "(v)", &_inner_reply);
		g_variant_unref (_reply);
	}
	_result = g_variant_get_boolean (_inner_reply);
	g_variant_unref (_inner_reply);
	return _result;
}


static void bluetooth_services_device_dbus_proxy_set_connected (BluetoothServicesDevice* self, gboolean value) {
	GVariant *_arguments;
	GVariant *_reply;
	GVariantBuilder _arguments_builder;
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("org.bluez.Device1"));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("Connected"));
	g_variant_builder_open (&_arguments_builder, G_VARIANT_TYPE_VARIANT);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_boolean (value));
	g_variant_builder_close (&_arguments_builder);
	_arguments = g_variant_builder_end (&_arguments_builder);
	_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Set", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
	if (!_reply) {
		return;
	}
	g_variant_unref (_reply);
}


static gboolean bluetooth_services_device_dbus_proxy_get_legacy_pairing (BluetoothServicesDevice* self) {
	GVariant *_inner_reply;
	gboolean _result;
	_inner_reply = g_dbus_proxy_get_cached_property ((GDBusProxy *) self, "LegacyPairing");
	if (!_inner_reply) {
		GVariant *_arguments;
		GVariant *_reply;
		GVariantBuilder _arguments_builder;
		g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("org.bluez.Device1"));
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("LegacyPairing"));
		_arguments = g_variant_builder_end (&_arguments_builder);
		_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Get", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
		if (!_reply) {
			gboolean _tmp37_ = FALSE;
			return _tmp37_;
		}
		g_variant_get (_reply, "(v)", &_inner_reply);
		g_variant_unref (_reply);
	}
	_result = g_variant_get_boolean (_inner_reply);
	g_variant_unref (_inner_reply);
	return _result;
}


static void bluetooth_services_device_dbus_proxy_set_legacy_pairing (BluetoothServicesDevice* self, gboolean value) {
	GVariant *_arguments;
	GVariant *_reply;
	GVariantBuilder _arguments_builder;
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("org.bluez.Device1"));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("LegacyPairing"));
	g_variant_builder_open (&_arguments_builder, G_VARIANT_TYPE_VARIANT);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_boolean (value));
	g_variant_builder_close (&_arguments_builder);
	_arguments = g_variant_builder_end (&_arguments_builder);
	_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Set", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
	if (!_reply) {
		return;
	}
	g_variant_unref (_reply);
}


static gboolean bluetooth_services_device_dbus_proxy_get_paired (BluetoothServicesDevice* self) {
	GVariant *_inner_reply;
	gboolean _result;
	_inner_reply = g_dbus_proxy_get_cached_property ((GDBusProxy *) self, "Paired");
	if (!_inner_reply) {
		GVariant *_arguments;
		GVariant *_reply;
		GVariantBuilder _arguments_builder;
		g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("org.bluez.Device1"));
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("Paired"));
		_arguments = g_variant_builder_end (&_arguments_builder);
		_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Get", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
		if (!_reply) {
			gboolean _tmp38_ = FALSE;
			return _tmp38_;
		}
		g_variant_get (_reply, "(v)", &_inner_reply);
		g_variant_unref (_reply);
	}
	_result = g_variant_get_boolean (_inner_reply);
	g_variant_unref (_inner_reply);
	return _result;
}


static void bluetooth_services_device_dbus_proxy_set_paired (BluetoothServicesDevice* self, gboolean value) {
	GVariant *_arguments;
	GVariant *_reply;
	GVariantBuilder _arguments_builder;
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("org.bluez.Device1"));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("Paired"));
	g_variant_builder_open (&_arguments_builder, G_VARIANT_TYPE_VARIANT);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_boolean (value));
	g_variant_builder_close (&_arguments_builder);
	_arguments = g_variant_builder_end (&_arguments_builder);
	_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Set", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
	if (!_reply) {
		return;
	}
	g_variant_unref (_reply);
}


static gboolean bluetooth_services_device_dbus_proxy_get_trusted (BluetoothServicesDevice* self) {
	GVariant *_inner_reply;
	gboolean _result;
	_inner_reply = g_dbus_proxy_get_cached_property ((GDBusProxy *) self, "Trusted");
	if (!_inner_reply) {
		GVariant *_arguments;
		GVariant *_reply;
		GVariantBuilder _arguments_builder;
		g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("org.bluez.Device1"));
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("Trusted"));
		_arguments = g_variant_builder_end (&_arguments_builder);
		_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Get", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
		if (!_reply) {
			gboolean _tmp39_ = FALSE;
			return _tmp39_;
		}
		g_variant_get (_reply, "(v)", &_inner_reply);
		g_variant_unref (_reply);
	}
	_result = g_variant_get_boolean (_inner_reply);
	g_variant_unref (_inner_reply);
	return _result;
}


static void bluetooth_services_device_dbus_proxy_set_trusted (BluetoothServicesDevice* self, gboolean value) {
	GVariant *_arguments;
	GVariant *_reply;
	GVariantBuilder _arguments_builder;
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("org.bluez.Device1"));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("Trusted"));
	g_variant_builder_open (&_arguments_builder, G_VARIANT_TYPE_VARIANT);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_boolean (value));
	g_variant_builder_close (&_arguments_builder);
	_arguments = g_variant_builder_end (&_arguments_builder);
	_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Set", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
	if (!_reply) {
		return;
	}
	g_variant_unref (_reply);
}


static gint16 bluetooth_services_device_dbus_proxy_get_RSSI (BluetoothServicesDevice* self) {
	GVariant *_inner_reply;
	gint16 _result;
	_inner_reply = g_dbus_proxy_get_cached_property ((GDBusProxy *) self, "RSSI");
	if (!_inner_reply) {
		GVariant *_arguments;
		GVariant *_reply;
		GVariantBuilder _arguments_builder;
		g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("org.bluez.Device1"));
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("RSSI"));
		_arguments = g_variant_builder_end (&_arguments_builder);
		_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Get", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
		if (!_reply) {
			gint16 _tmp40_ = 0;
			return _tmp40_;
		}
		g_variant_get (_reply, "(v)", &_inner_reply);
		g_variant_unref (_reply);
	}
	_result = g_variant_get_int16 (_inner_reply);
	g_variant_unref (_inner_reply);
	return _result;
}


static void bluetooth_services_device_dbus_proxy_set_RSSI (BluetoothServicesDevice* self, gint16 value) {
	GVariant *_arguments;
	GVariant *_reply;
	GVariantBuilder _arguments_builder;
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("org.bluez.Device1"));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("RSSI"));
	g_variant_builder_open (&_arguments_builder, G_VARIANT_TYPE_VARIANT);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_int16 (value));
	g_variant_builder_close (&_arguments_builder);
	_arguments = g_variant_builder_end (&_arguments_builder);
	_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Set", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
	if (!_reply) {
		return;
	}
	g_variant_unref (_reply);
}


static char* bluetooth_services_device_dbus_proxy_get_adapter (BluetoothServicesDevice* self) {
	GVariant *_inner_reply;
	char* _result;
	_inner_reply = g_dbus_proxy_get_cached_property ((GDBusProxy *) self, "Adapter");
	if (!_inner_reply) {
		GVariant *_arguments;
		GVariant *_reply;
		GVariantBuilder _arguments_builder;
		g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("org.bluez.Device1"));
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("Adapter"));
		_arguments = g_variant_builder_end (&_arguments_builder);
		_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Get", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
		if (!_reply) {
			return NULL;
		}
		g_variant_get (_reply, "(v)", &_inner_reply);
		g_variant_unref (_reply);
	}
	_result = g_variant_dup_string (_inner_reply, NULL);
	g_variant_unref (_inner_reply);
	return _result;
}


static void bluetooth_services_device_dbus_proxy_set_adapter (BluetoothServicesDevice* self, const char* value) {
	GVariant *_arguments;
	GVariant *_reply;
	GVariantBuilder _arguments_builder;
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("org.bluez.Device1"));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("Adapter"));
	g_variant_builder_open (&_arguments_builder, G_VARIANT_TYPE_VARIANT);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_object_path (value));
	g_variant_builder_close (&_arguments_builder);
	_arguments = g_variant_builder_end (&_arguments_builder);
	_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Set", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
	if (!_reply) {
		return;
	}
	g_variant_unref (_reply);
}


static gchar* bluetooth_services_device_dbus_proxy_get_address (BluetoothServicesDevice* self) {
	GVariant *_inner_reply;
	gchar* _result;
	_inner_reply = g_dbus_proxy_get_cached_property ((GDBusProxy *) self, "Address");
	if (!_inner_reply) {
		GVariant *_arguments;
		GVariant *_reply;
		GVariantBuilder _arguments_builder;
		g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("org.bluez.Device1"));
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("Address"));
		_arguments = g_variant_builder_end (&_arguments_builder);
		_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Get", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
		if (!_reply) {
			return NULL;
		}
		g_variant_get (_reply, "(v)", &_inner_reply);
		g_variant_unref (_reply);
	}
	_result = g_variant_dup_string (_inner_reply, NULL);
	g_variant_unref (_inner_reply);
	return _result;
}


static void bluetooth_services_device_dbus_proxy_set_address (BluetoothServicesDevice* self, const gchar* value) {
	GVariant *_arguments;
	GVariant *_reply;
	GVariantBuilder _arguments_builder;
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("org.bluez.Device1"));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("Address"));
	g_variant_builder_open (&_arguments_builder, G_VARIANT_TYPE_VARIANT);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (value));
	g_variant_builder_close (&_arguments_builder);
	_arguments = g_variant_builder_end (&_arguments_builder);
	_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Set", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
	if (!_reply) {
		return;
	}
	g_variant_unref (_reply);
}


static gchar* bluetooth_services_device_dbus_proxy_get_alias (BluetoothServicesDevice* self) {
	GVariant *_inner_reply;
	gchar* _result;
	_inner_reply = g_dbus_proxy_get_cached_property ((GDBusProxy *) self, "Alias");
	if (!_inner_reply) {
		GVariant *_arguments;
		GVariant *_reply;
		GVariantBuilder _arguments_builder;
		g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("org.bluez.Device1"));
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("Alias"));
		_arguments = g_variant_builder_end (&_arguments_builder);
		_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Get", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
		if (!_reply) {
			return NULL;
		}
		g_variant_get (_reply, "(v)", &_inner_reply);
		g_variant_unref (_reply);
	}
	_result = g_variant_dup_string (_inner_reply, NULL);
	g_variant_unref (_inner_reply);
	return _result;
}


static void bluetooth_services_device_dbus_proxy_set_alias (BluetoothServicesDevice* self, const gchar* value) {
	GVariant *_arguments;
	GVariant *_reply;
	GVariantBuilder _arguments_builder;
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("org.bluez.Device1"));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("Alias"));
	g_variant_builder_open (&_arguments_builder, G_VARIANT_TYPE_VARIANT);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (value));
	g_variant_builder_close (&_arguments_builder);
	_arguments = g_variant_builder_end (&_arguments_builder);
	_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Set", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
	if (!_reply) {
		return;
	}
	g_variant_unref (_reply);
}


static gchar* bluetooth_services_device_dbus_proxy_get_icon (BluetoothServicesDevice* self) {
	GVariant *_inner_reply;
	gchar* _result;
	_inner_reply = g_dbus_proxy_get_cached_property ((GDBusProxy *) self, "Icon");
	if (!_inner_reply) {
		GVariant *_arguments;
		GVariant *_reply;
		GVariantBuilder _arguments_builder;
		g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("org.bluez.Device1"));
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("Icon"));
		_arguments = g_variant_builder_end (&_arguments_builder);
		_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Get", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
		if (!_reply) {
			return NULL;
		}
		g_variant_get (_reply, "(v)", &_inner_reply);
		g_variant_unref (_reply);
	}
	_result = g_variant_dup_string (_inner_reply, NULL);
	g_variant_unref (_inner_reply);
	return _result;
}


static void bluetooth_services_device_dbus_proxy_set_icon (BluetoothServicesDevice* self, const gchar* value) {
	GVariant *_arguments;
	GVariant *_reply;
	GVariantBuilder _arguments_builder;
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("org.bluez.Device1"));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("Icon"));
	g_variant_builder_open (&_arguments_builder, G_VARIANT_TYPE_VARIANT);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (value));
	g_variant_builder_close (&_arguments_builder);
	_arguments = g_variant_builder_end (&_arguments_builder);
	_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Set", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
	if (!_reply) {
		return;
	}
	g_variant_unref (_reply);
}


static gchar* bluetooth_services_device_dbus_proxy_get_modalias (BluetoothServicesDevice* self) {
	GVariant *_inner_reply;
	gchar* _result;
	_inner_reply = g_dbus_proxy_get_cached_property ((GDBusProxy *) self, "Modalias");
	if (!_inner_reply) {
		GVariant *_arguments;
		GVariant *_reply;
		GVariantBuilder _arguments_builder;
		g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("org.bluez.Device1"));
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("Modalias"));
		_arguments = g_variant_builder_end (&_arguments_builder);
		_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Get", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
		if (!_reply) {
			return NULL;
		}
		g_variant_get (_reply, "(v)", &_inner_reply);
		g_variant_unref (_reply);
	}
	_result = g_variant_dup_string (_inner_reply, NULL);
	g_variant_unref (_inner_reply);
	return _result;
}


static void bluetooth_services_device_dbus_proxy_set_modalias (BluetoothServicesDevice* self, const gchar* value) {
	GVariant *_arguments;
	GVariant *_reply;
	GVariantBuilder _arguments_builder;
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("org.bluez.Device1"));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("Modalias"));
	g_variant_builder_open (&_arguments_builder, G_VARIANT_TYPE_VARIANT);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (value));
	g_variant_builder_close (&_arguments_builder);
	_arguments = g_variant_builder_end (&_arguments_builder);
	_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Set", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
	if (!_reply) {
		return;
	}
	g_variant_unref (_reply);
}


static gchar* bluetooth_services_device_dbus_proxy_get_name (BluetoothServicesDevice* self) {
	GVariant *_inner_reply;
	gchar* _result;
	_inner_reply = g_dbus_proxy_get_cached_property ((GDBusProxy *) self, "Name");
	if (!_inner_reply) {
		GVariant *_arguments;
		GVariant *_reply;
		GVariantBuilder _arguments_builder;
		g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("org.bluez.Device1"));
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("Name"));
		_arguments = g_variant_builder_end (&_arguments_builder);
		_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Get", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
		if (!_reply) {
			return NULL;
		}
		g_variant_get (_reply, "(v)", &_inner_reply);
		g_variant_unref (_reply);
	}
	_result = g_variant_dup_string (_inner_reply, NULL);
	g_variant_unref (_inner_reply);
	return _result;
}


static void bluetooth_services_device_dbus_proxy_set_name (BluetoothServicesDevice* self, const gchar* value) {
	GVariant *_arguments;
	GVariant *_reply;
	GVariantBuilder _arguments_builder;
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("org.bluez.Device1"));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("Name"));
	g_variant_builder_open (&_arguments_builder, G_VARIANT_TYPE_VARIANT);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (value));
	g_variant_builder_close (&_arguments_builder);
	_arguments = g_variant_builder_end (&_arguments_builder);
	_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Set", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
	if (!_reply) {
		return;
	}
	g_variant_unref (_reply);
}


static guint16 bluetooth_services_device_dbus_proxy_get_appearance (BluetoothServicesDevice* self) {
	GVariant *_inner_reply;
	guint16 _result;
	_inner_reply = g_dbus_proxy_get_cached_property ((GDBusProxy *) self, "Appearance");
	if (!_inner_reply) {
		GVariant *_arguments;
		GVariant *_reply;
		GVariantBuilder _arguments_builder;
		g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("org.bluez.Device1"));
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("Appearance"));
		_arguments = g_variant_builder_end (&_arguments_builder);
		_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Get", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
		if (!_reply) {
			guint16 _tmp41_ = 0U;
			return _tmp41_;
		}
		g_variant_get (_reply, "(v)", &_inner_reply);
		g_variant_unref (_reply);
	}
	_result = g_variant_get_uint16 (_inner_reply);
	g_variant_unref (_inner_reply);
	return _result;
}


static void bluetooth_services_device_dbus_proxy_set_appearance (BluetoothServicesDevice* self, guint16 value) {
	GVariant *_arguments;
	GVariant *_reply;
	GVariantBuilder _arguments_builder;
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("org.bluez.Device1"));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("Appearance"));
	g_variant_builder_open (&_arguments_builder, G_VARIANT_TYPE_VARIANT);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_uint16 (value));
	g_variant_builder_close (&_arguments_builder);
	_arguments = g_variant_builder_end (&_arguments_builder);
	_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Set", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
	if (!_reply) {
		return;
	}
	g_variant_unref (_reply);
}


static guint32 bluetooth_services_device_dbus_proxy_get_class (BluetoothServicesDevice* self) {
	GVariant *_inner_reply;
	guint32 _result;
	_inner_reply = g_dbus_proxy_get_cached_property ((GDBusProxy *) self, "Class");
	if (!_inner_reply) {
		GVariant *_arguments;
		GVariant *_reply;
		GVariantBuilder _arguments_builder;
		g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("org.bluez.Device1"));
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("Class"));
		_arguments = g_variant_builder_end (&_arguments_builder);
		_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Get", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
		if (!_reply) {
			guint32 _tmp42_ = 0U;
			return _tmp42_;
		}
		g_variant_get (_reply, "(v)", &_inner_reply);
		g_variant_unref (_reply);
	}
	_result = g_variant_get_uint32 (_inner_reply);
	g_variant_unref (_inner_reply);
	return _result;
}


static void bluetooth_services_device_dbus_proxy_set_class (BluetoothServicesDevice* self, guint32 value) {
	GVariant *_arguments;
	GVariant *_reply;
	GVariantBuilder _arguments_builder;
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("org.bluez.Device1"));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("Class"));
	g_variant_builder_open (&_arguments_builder, G_VARIANT_TYPE_VARIANT);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_uint32 (value));
	g_variant_builder_close (&_arguments_builder);
	_arguments = g_variant_builder_end (&_arguments_builder);
	_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Set", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
	if (!_reply) {
		return;
	}
	g_variant_unref (_reply);
}


static void bluetooth_services_device_proxy_bluetooth_services_device_interface_init (BluetoothServicesDeviceIface* iface) {
	iface->cancel_pairing = bluetooth_services_device_proxy_cancel_pairing;
	iface->connect = bluetooth_services_device_proxy_connect;
	iface->connect_profile = bluetooth_services_device_proxy_connect_profile;
	iface->disconnect = bluetooth_services_device_proxy_disconnect;
	iface->disconnect_profile = bluetooth_services_device_proxy_disconnect_profile;
	iface->pair = bluetooth_services_device_proxy_pair;
	iface->get_UUIDs = bluetooth_services_device_dbus_proxy_get_UUIDs;
	iface->set_UUIDs = bluetooth_services_device_dbus_proxy_set_UUIDs;
	iface->get_blocked = bluetooth_services_device_dbus_proxy_get_blocked;
	iface->set_blocked = bluetooth_services_device_dbus_proxy_set_blocked;
	iface->get_connected = bluetooth_services_device_dbus_proxy_get_connected;
	iface->set_connected = bluetooth_services_device_dbus_proxy_set_connected;
	iface->get_legacy_pairing = bluetooth_services_device_dbus_proxy_get_legacy_pairing;
	iface->set_legacy_pairing = bluetooth_services_device_dbus_proxy_set_legacy_pairing;
	iface->get_paired = bluetooth_services_device_dbus_proxy_get_paired;
	iface->set_paired = bluetooth_services_device_dbus_proxy_set_paired;
	iface->get_trusted = bluetooth_services_device_dbus_proxy_get_trusted;
	iface->set_trusted = bluetooth_services_device_dbus_proxy_set_trusted;
	iface->get_RSSI = bluetooth_services_device_dbus_proxy_get_RSSI;
	iface->set_RSSI = bluetooth_services_device_dbus_proxy_set_RSSI;
	iface->get_adapter = bluetooth_services_device_dbus_proxy_get_adapter;
	iface->set_adapter = bluetooth_services_device_dbus_proxy_set_adapter;
	iface->get_address = bluetooth_services_device_dbus_proxy_get_address;
	iface->set_address = bluetooth_services_device_dbus_proxy_set_address;
	iface->get_alias = bluetooth_services_device_dbus_proxy_get_alias;
	iface->set_alias = bluetooth_services_device_dbus_proxy_set_alias;
	iface->get_icon = bluetooth_services_device_dbus_proxy_get_icon;
	iface->set_icon = bluetooth_services_device_dbus_proxy_set_icon;
	iface->get_modalias = bluetooth_services_device_dbus_proxy_get_modalias;
	iface->set_modalias = bluetooth_services_device_dbus_proxy_set_modalias;
	iface->get_name = bluetooth_services_device_dbus_proxy_get_name;
	iface->set_name = bluetooth_services_device_dbus_proxy_set_name;
	iface->get_appearance = bluetooth_services_device_dbus_proxy_get_appearance;
	iface->set_appearance = bluetooth_services_device_dbus_proxy_set_appearance;
	iface->get_class = bluetooth_services_device_dbus_proxy_get_class;
	iface->set_class = bluetooth_services_device_dbus_proxy_set_class;
}


static void _dbus_bluetooth_services_device_cancel_pairing (BluetoothServicesDevice* self, GVariant* _parameters_, GDBusMethodInvocation* invocation) {
	GError* error = NULL;
	GVariantIter _arguments_iter;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	bluetooth_services_device_cancel_pairing (self, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void _dbus_bluetooth_services_device_connect (BluetoothServicesDevice* self, GVariant* _parameters_, GDBusMethodInvocation* invocation) {
	GError* error = NULL;
	GVariantIter _arguments_iter;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	bluetooth_services_device_connect (self, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void _dbus_bluetooth_services_device_connect_profile (BluetoothServicesDevice* self, GVariant* _parameters_, GDBusMethodInvocation* invocation) {
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gchar* UUID = NULL;
	GVariant* _tmp43_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp43_ = g_variant_iter_next_value (&_arguments_iter);
	UUID = g_variant_dup_string (_tmp43_, NULL);
	g_variant_unref (_tmp43_);
	bluetooth_services_device_connect_profile (self, UUID, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	_g_free0 (UUID);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void _dbus_bluetooth_services_device_disconnect (BluetoothServicesDevice* self, GVariant* _parameters_, GDBusMethodInvocation* invocation) {
	GError* error = NULL;
	GVariantIter _arguments_iter;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	bluetooth_services_device_disconnect (self, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void _dbus_bluetooth_services_device_disconnect_profile (BluetoothServicesDevice* self, GVariant* _parameters_, GDBusMethodInvocation* invocation) {
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gchar* UUID = NULL;
	GVariant* _tmp44_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp44_ = g_variant_iter_next_value (&_arguments_iter);
	UUID = g_variant_dup_string (_tmp44_, NULL);
	g_variant_unref (_tmp44_);
	bluetooth_services_device_disconnect_profile (self, UUID, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	_g_free0 (UUID);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void _dbus_bluetooth_services_device_pair (BluetoothServicesDevice* self, GVariant* _parameters_, GDBusMethodInvocation* invocation) {
	GError* error = NULL;
	GVariantIter _arguments_iter;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	bluetooth_services_device_pair (self, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void bluetooth_services_device_dbus_interface_method_call (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* method_name, GVariant* parameters, GDBusMethodInvocation* invocation, gpointer user_data) {
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	if (strcmp (method_name, "CancelPairing") == 0) {
		_dbus_bluetooth_services_device_cancel_pairing (object, parameters, invocation);
	} else if (strcmp (method_name, "Connect") == 0) {
		_dbus_bluetooth_services_device_connect (object, parameters, invocation);
	} else if (strcmp (method_name, "ConnectProfile") == 0) {
		_dbus_bluetooth_services_device_connect_profile (object, parameters, invocation);
	} else if (strcmp (method_name, "Disconnect") == 0) {
		_dbus_bluetooth_services_device_disconnect (object, parameters, invocation);
	} else if (strcmp (method_name, "DisconnectProfile") == 0) {
		_dbus_bluetooth_services_device_disconnect_profile (object, parameters, invocation);
	} else if (strcmp (method_name, "Pair") == 0) {
		_dbus_bluetooth_services_device_pair (object, parameters, invocation);
	} else {
		g_object_unref (invocation);
	}
}


static GVariant* _dbus_bluetooth_services_device_get_UUIDs (BluetoothServicesDevice* self) {
	gchar** result;
	int result_length1 = 0;
	GVariant* _reply;
	gchar** _tmp45_;
	GVariantBuilder _tmp46_;
	int _tmp47_;
	result = bluetooth_services_device_get_UUIDs (self, &result_length1);
	_tmp45_ = result;
	g_variant_builder_init (&_tmp46_, G_VARIANT_TYPE ("as"));
	for (_tmp47_ = 0; _tmp47_ < result_length1; _tmp47_++) {
		g_variant_builder_add_value (&_tmp46_, g_variant_new_string (*_tmp45_));
		_tmp45_++;
	}
	_reply = g_variant_builder_end (&_tmp46_);
	result = (_vala_array_free (result, result_length1, (GDestroyNotify) g_free), NULL);
	return _reply;
}


static GVariant* _dbus_bluetooth_services_device_get_blocked (BluetoothServicesDevice* self) {
	gboolean result;
	GVariant* _reply;
	result = bluetooth_services_device_get_blocked (self);
	_reply = g_variant_new_boolean (result);
	return _reply;
}


static GVariant* _dbus_bluetooth_services_device_get_connected (BluetoothServicesDevice* self) {
	gboolean result;
	GVariant* _reply;
	result = bluetooth_services_device_get_connected (self);
	_reply = g_variant_new_boolean (result);
	return _reply;
}


static GVariant* _dbus_bluetooth_services_device_get_legacy_pairing (BluetoothServicesDevice* self) {
	gboolean result;
	GVariant* _reply;
	result = bluetooth_services_device_get_legacy_pairing (self);
	_reply = g_variant_new_boolean (result);
	return _reply;
}


static GVariant* _dbus_bluetooth_services_device_get_paired (BluetoothServicesDevice* self) {
	gboolean result;
	GVariant* _reply;
	result = bluetooth_services_device_get_paired (self);
	_reply = g_variant_new_boolean (result);
	return _reply;
}


static GVariant* _dbus_bluetooth_services_device_get_trusted (BluetoothServicesDevice* self) {
	gboolean result;
	GVariant* _reply;
	result = bluetooth_services_device_get_trusted (self);
	_reply = g_variant_new_boolean (result);
	return _reply;
}


static GVariant* _dbus_bluetooth_services_device_get_RSSI (BluetoothServicesDevice* self) {
	gint16 result;
	GVariant* _reply;
	result = bluetooth_services_device_get_RSSI (self);
	_reply = g_variant_new_int16 (result);
	return _reply;
}


static GVariant* _dbus_bluetooth_services_device_get_adapter (BluetoothServicesDevice* self) {
	char* result;
	GVariant* _reply;
	result = bluetooth_services_device_get_adapter (self);
	_reply = g_variant_new_object_path (result);
	_g_free0 (result);
	return _reply;
}


static GVariant* _dbus_bluetooth_services_device_get_address (BluetoothServicesDevice* self) {
	gchar* result;
	GVariant* _reply;
	result = bluetooth_services_device_get_address (self);
	_reply = g_variant_new_string (result);
	_g_free0 (result);
	return _reply;
}


static GVariant* _dbus_bluetooth_services_device_get_alias (BluetoothServicesDevice* self) {
	gchar* result;
	GVariant* _reply;
	result = bluetooth_services_device_get_alias (self);
	_reply = g_variant_new_string (result);
	_g_free0 (result);
	return _reply;
}


static GVariant* _dbus_bluetooth_services_device_get_icon (BluetoothServicesDevice* self) {
	gchar* result;
	GVariant* _reply;
	result = bluetooth_services_device_get_icon (self);
	_reply = g_variant_new_string (result);
	_g_free0 (result);
	return _reply;
}


static GVariant* _dbus_bluetooth_services_device_get_modalias (BluetoothServicesDevice* self) {
	gchar* result;
	GVariant* _reply;
	result = bluetooth_services_device_get_modalias (self);
	_reply = g_variant_new_string (result);
	_g_free0 (result);
	return _reply;
}


static GVariant* _dbus_bluetooth_services_device_get_name (BluetoothServicesDevice* self) {
	gchar* result;
	GVariant* _reply;
	result = bluetooth_services_device_get_name (self);
	_reply = g_variant_new_string (result);
	_g_free0 (result);
	return _reply;
}


static GVariant* _dbus_bluetooth_services_device_get_appearance (BluetoothServicesDevice* self) {
	guint16 result;
	GVariant* _reply;
	result = bluetooth_services_device_get_appearance (self);
	_reply = g_variant_new_uint16 (result);
	return _reply;
}


static GVariant* _dbus_bluetooth_services_device_get_class (BluetoothServicesDevice* self) {
	guint32 result;
	GVariant* _reply;
	result = bluetooth_services_device_get_class (self);
	_reply = g_variant_new_uint32 (result);
	return _reply;
}


static GVariant* bluetooth_services_device_dbus_interface_get_property (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* property_name, GError** error, gpointer user_data) {
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	if (strcmp (property_name, "UUIDs") == 0) {
		return _dbus_bluetooth_services_device_get_UUIDs (object);
	} else if (strcmp (property_name, "Blocked") == 0) {
		return _dbus_bluetooth_services_device_get_blocked (object);
	} else if (strcmp (property_name, "Connected") == 0) {
		return _dbus_bluetooth_services_device_get_connected (object);
	} else if (strcmp (property_name, "LegacyPairing") == 0) {
		return _dbus_bluetooth_services_device_get_legacy_pairing (object);
	} else if (strcmp (property_name, "Paired") == 0) {
		return _dbus_bluetooth_services_device_get_paired (object);
	} else if (strcmp (property_name, "Trusted") == 0) {
		return _dbus_bluetooth_services_device_get_trusted (object);
	} else if (strcmp (property_name, "RSSI") == 0) {
		return _dbus_bluetooth_services_device_get_RSSI (object);
	} else if (strcmp (property_name, "Adapter") == 0) {
		return _dbus_bluetooth_services_device_get_adapter (object);
	} else if (strcmp (property_name, "Address") == 0) {
		return _dbus_bluetooth_services_device_get_address (object);
	} else if (strcmp (property_name, "Alias") == 0) {
		return _dbus_bluetooth_services_device_get_alias (object);
	} else if (strcmp (property_name, "Icon") == 0) {
		return _dbus_bluetooth_services_device_get_icon (object);
	} else if (strcmp (property_name, "Modalias") == 0) {
		return _dbus_bluetooth_services_device_get_modalias (object);
	} else if (strcmp (property_name, "Name") == 0) {
		return _dbus_bluetooth_services_device_get_name (object);
	} else if (strcmp (property_name, "Appearance") == 0) {
		return _dbus_bluetooth_services_device_get_appearance (object);
	} else if (strcmp (property_name, "Class") == 0) {
		return _dbus_bluetooth_services_device_get_class (object);
	}
	return NULL;
}


static void _dbus_bluetooth_services_device_set_UUIDs (BluetoothServicesDevice* self, GVariant* _value) {
	gchar** value = NULL;
	int value_length1;
	gchar** _tmp48_;
	int _tmp48__length;
	int _tmp48__size;
	int _tmp48__length1;
	GVariantIter _tmp49_;
	GVariant* _tmp50_;
	_tmp48_ = g_new (gchar*, 5);
	_tmp48__length = 0;
	_tmp48__size = 4;
	_tmp48__length1 = 0;
	g_variant_iter_init (&_tmp49_, _value);
	for (; (_tmp50_ = g_variant_iter_next_value (&_tmp49_)) != NULL; _tmp48__length1++) {
		if (_tmp48__size == _tmp48__length) {
			_tmp48__size = 2 * _tmp48__size;
			_tmp48_ = g_renew (gchar*, _tmp48_, _tmp48__size + 1);
		}
		_tmp48_[_tmp48__length++] = g_variant_dup_string (_tmp50_, NULL);
		g_variant_unref (_tmp50_);
	}
	value_length1 = _tmp48__length1;
	_tmp48_[_tmp48__length] = NULL;
	value = _tmp48_;
	bluetooth_services_device_set_UUIDs (self, value, value_length1);
	value = (_vala_array_free (value, value_length1, (GDestroyNotify) g_free), NULL);
}


static void _dbus_bluetooth_services_device_set_blocked (BluetoothServicesDevice* self, GVariant* _value) {
	gboolean value = FALSE;
	value = g_variant_get_boolean (_value);
	bluetooth_services_device_set_blocked (self, value);
}


static void _dbus_bluetooth_services_device_set_connected (BluetoothServicesDevice* self, GVariant* _value) {
	gboolean value = FALSE;
	value = g_variant_get_boolean (_value);
	bluetooth_services_device_set_connected (self, value);
}


static void _dbus_bluetooth_services_device_set_legacy_pairing (BluetoothServicesDevice* self, GVariant* _value) {
	gboolean value = FALSE;
	value = g_variant_get_boolean (_value);
	bluetooth_services_device_set_legacy_pairing (self, value);
}


static void _dbus_bluetooth_services_device_set_paired (BluetoothServicesDevice* self, GVariant* _value) {
	gboolean value = FALSE;
	value = g_variant_get_boolean (_value);
	bluetooth_services_device_set_paired (self, value);
}


static void _dbus_bluetooth_services_device_set_trusted (BluetoothServicesDevice* self, GVariant* _value) {
	gboolean value = FALSE;
	value = g_variant_get_boolean (_value);
	bluetooth_services_device_set_trusted (self, value);
}


static void _dbus_bluetooth_services_device_set_RSSI (BluetoothServicesDevice* self, GVariant* _value) {
	gint16 value = 0;
	value = g_variant_get_int16 (_value);
	bluetooth_services_device_set_RSSI (self, value);
}


static void _dbus_bluetooth_services_device_set_adapter (BluetoothServicesDevice* self, GVariant* _value) {
	char* value = NULL;
	value = g_variant_dup_string (_value, NULL);
	bluetooth_services_device_set_adapter (self, value);
	_g_free0 (value);
}


static void _dbus_bluetooth_services_device_set_address (BluetoothServicesDevice* self, GVariant* _value) {
	gchar* value = NULL;
	value = g_variant_dup_string (_value, NULL);
	bluetooth_services_device_set_address (self, value);
	_g_free0 (value);
}


static void _dbus_bluetooth_services_device_set_alias (BluetoothServicesDevice* self, GVariant* _value) {
	gchar* value = NULL;
	value = g_variant_dup_string (_value, NULL);
	bluetooth_services_device_set_alias (self, value);
	_g_free0 (value);
}


static void _dbus_bluetooth_services_device_set_icon (BluetoothServicesDevice* self, GVariant* _value) {
	gchar* value = NULL;
	value = g_variant_dup_string (_value, NULL);
	bluetooth_services_device_set_icon (self, value);
	_g_free0 (value);
}


static void _dbus_bluetooth_services_device_set_modalias (BluetoothServicesDevice* self, GVariant* _value) {
	gchar* value = NULL;
	value = g_variant_dup_string (_value, NULL);
	bluetooth_services_device_set_modalias (self, value);
	_g_free0 (value);
}


static void _dbus_bluetooth_services_device_set_name (BluetoothServicesDevice* self, GVariant* _value) {
	gchar* value = NULL;
	value = g_variant_dup_string (_value, NULL);
	bluetooth_services_device_set_name (self, value);
	_g_free0 (value);
}


static void _dbus_bluetooth_services_device_set_appearance (BluetoothServicesDevice* self, GVariant* _value) {
	guint16 value = 0U;
	value = g_variant_get_uint16 (_value);
	bluetooth_services_device_set_appearance (self, value);
}


static void _dbus_bluetooth_services_device_set_class (BluetoothServicesDevice* self, GVariant* _value) {
	guint32 value = 0U;
	value = g_variant_get_uint32 (_value);
	bluetooth_services_device_set_class (self, value);
}


static gboolean bluetooth_services_device_dbus_interface_set_property (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* property_name, GVariant* value, GError** error, gpointer user_data) {
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	if (strcmp (property_name, "UUIDs") == 0) {
		_dbus_bluetooth_services_device_set_UUIDs (object, value);
		return TRUE;
	} else if (strcmp (property_name, "Blocked") == 0) {
		_dbus_bluetooth_services_device_set_blocked (object, value);
		return TRUE;
	} else if (strcmp (property_name, "Connected") == 0) {
		_dbus_bluetooth_services_device_set_connected (object, value);
		return TRUE;
	} else if (strcmp (property_name, "LegacyPairing") == 0) {
		_dbus_bluetooth_services_device_set_legacy_pairing (object, value);
		return TRUE;
	} else if (strcmp (property_name, "Paired") == 0) {
		_dbus_bluetooth_services_device_set_paired (object, value);
		return TRUE;
	} else if (strcmp (property_name, "Trusted") == 0) {
		_dbus_bluetooth_services_device_set_trusted (object, value);
		return TRUE;
	} else if (strcmp (property_name, "RSSI") == 0) {
		_dbus_bluetooth_services_device_set_RSSI (object, value);
		return TRUE;
	} else if (strcmp (property_name, "Adapter") == 0) {
		_dbus_bluetooth_services_device_set_adapter (object, value);
		return TRUE;
	} else if (strcmp (property_name, "Address") == 0) {
		_dbus_bluetooth_services_device_set_address (object, value);
		return TRUE;
	} else if (strcmp (property_name, "Alias") == 0) {
		_dbus_bluetooth_services_device_set_alias (object, value);
		return TRUE;
	} else if (strcmp (property_name, "Icon") == 0) {
		_dbus_bluetooth_services_device_set_icon (object, value);
		return TRUE;
	} else if (strcmp (property_name, "Modalias") == 0) {
		_dbus_bluetooth_services_device_set_modalias (object, value);
		return TRUE;
	} else if (strcmp (property_name, "Name") == 0) {
		_dbus_bluetooth_services_device_set_name (object, value);
		return TRUE;
	} else if (strcmp (property_name, "Appearance") == 0) {
		_dbus_bluetooth_services_device_set_appearance (object, value);
		return TRUE;
	} else if (strcmp (property_name, "Class") == 0) {
		_dbus_bluetooth_services_device_set_class (object, value);
		return TRUE;
	}
	return FALSE;
}


guint bluetooth_services_device_register_object (gpointer object, GDBusConnection* connection, const gchar* path, GError** error) {
	guint result;
	gpointer *data;
	data = g_new (gpointer, 3);
	data[0] = g_object_ref (object);
	data[1] = g_object_ref (connection);
	data[2] = g_strdup (path);
	result = g_dbus_connection_register_object (connection, path, (GDBusInterfaceInfo *) (&_bluetooth_services_device_dbus_interface_info), &_bluetooth_services_device_dbus_interface_vtable, data, _bluetooth_services_device_unregister_object, error);
	if (!result) {
		return 0;
	}
	return result;
}


static void _bluetooth_services_device_unregister_object (gpointer user_data) {
	gpointer* data;
	data = user_data;
	g_object_unref (data[0]);
	g_object_unref (data[1]);
	g_free (data[2]);
	g_free (data);
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}



